Package: JohnsonKinaseData
Title: Kinase PWMs based on data published by Johnson et al. 2023 and
        Yaron-Barir et al. 2024
Version: 1.8.0
Date: 2023-09-24
Authors@R: 
    person("Florian", "Geier", , "florian.geier@unibas.ch", role = c("aut", "cre"),
           comment = c(ORCID = "0000-0002-9076-9264"))
Description: The packages provides position specific weight matrices (PWMs) for 303 human serine/threonine and 93 tyrosine kinases originally published in Johnson et al. 2023 (doi:10.1038/s41586-022-05575-3) and Yaron-Barir et al. 2024 (doi:10.1038/s41586-024-07407-y). The package includes basic functionality to score user provided phosphosites. It also includes pre-computed PWM scores ("background scores") for a large collection of curated human phosphosites which can be used to rank PWM scores relative to the background scores ("percentile rank").
License: MIT + file LICENSE
URL: https://github.com/fgeier/JohnsonKinaseData/
BugReports: https://support.bioconductor.org/t/JohnsonKinaseData
Imports: ExperimentHub, BiocParallel, checkmate, dplyr, stats, stringr,
        tidyr, purrr, utils
Suggests: knitr, BiocStyle, ExperimentHubData, testthat (>= 3.0.0),
        rmarkdown
biocViews: ExperimentHub, Homo_sapiens_Data, Proteome
VignetteBuilder: knitr
Encoding: UTF-8
Roxygen: list(markdown = TRUE)
RoxygenNote: 7.3.2
Config/testthat/edition: 3
git_url: https://git.bioconductor.org/packages/JohnsonKinaseData
git_branch: RELEASE_3_23
git_last_commit: 087607c
git_last_commit_date: 2026-04-28
Repository: Bioconductor 3.23
Date/Publication: 2026-05-05
NeedsCompilation: no
Packaged: 2026-05-05 15:30:06 UTC; biocbuild
Author: Florian Geier [aut, cre] (ORCID:
    <https://orcid.org/0000-0002-9076-9264>)
Maintainer: Florian Geier <florian.geier@unibas.ch>
Depends: R (>= 4.1.0)

# JohnsonKinaseData

`JohnsonKinaseData` is an
R/[ExperimentHub](https://bioconductor.org/packages/release/bioc/html/ExperimentHub.html)
package providing access to position specific weight matrices (PWMs) for 303 
human serine/threonine and 93 tyrosine kinases originally published in 
Johnson et al. and Yaron-Barir et al.

The package includes functionality to match PWMs against user-provided 
phosphosites and to convert PWM scores into percentile ranks using background
score distributions.

All data records are available under
[https://zenodo.org/records/10628874](https://zenodo.org/records/10628874) and 
[https://zenodo.org/records/13785426](https://zenodo.org/records/13785426)
according to open data standards and licenses under the [Creative
Commons Attribution 4.0 International license (CC-BY
4.0)](https://creativecommons.org/licenses/by/4.0/).

## References

Johnson, J.L., Yaron, T.M., Huntsman, E.M. et al. An atlas of
substrate specificities for the human serine/threonine kinome. Nature
613, 759–766 (2023). [https://doi.org/10.1038/s41586-022-05575-3](https://doi.org/10.1038/s41586-022-05575-3)

Yaron-Barir, T.M., Joughin, B.A., Huntsman, E.M. et al. The intrinsic
substrate specificity of the human tyrosine kinome. Nature 629, 1174–1181
(2024). [https://doi.org/10.1038/s41586-024-07407-y](https://doi.org/10.1038/s41586-024-07407-y)

.onLoad <- function(libname, pkgname) {
    fl <- system.file("extdata", "metadata.csv", package=pkgname)
    titles <- read.csv(fl, stringsAsFactors=FALSE)$Title
    ## create hub accessors from titles as internal functions    
    ns <- asNamespace(pkgname)
    for (title in titles) {
        interal <- paste0('.', title)
        assign(interal, ExperimentHub:::.hubAccessorFactory(pkgname, title), 
               envir = ns)
        namespaceExport(ns, interal)
    }
}

#' Get annnotation data for all kinase PWMs
#'
#' The annotation data records for each kinase PWM, the PWM matrix name, gene
#' symbol and description, Uniprot ID, Entrez ID, acceptor specificity, kinase
#' sub-type, as well as the kinase family.
#'
#' Kinase PWMs are either serine/threonine or tyrosine specific in their central
#' phospho-acceptor. For dual-specific kinases, the tyrosine-specific PWM is
#' indicated by the '_TYR' suffix in the PWM name.
#'
#' Tyrosine kinases are further distinguished by sub-type and include receptor
#' tyrosine kinases (RTK), non-receptor tyrosine kinases (nRTK) and
#' non-canonical tyrosine kinases (ncTK) with dual-specificity.
#'
#' @return A data frame with columns MatrixName, GeneName, UniprotID, EntrezID,
#'   Description, AcceptorSpecificity, KinaseSubType and KinaseFamily
#'
#' @importFrom ExperimentHub ExperimentHub
#' @importFrom ExperimentHub createHubAccessors
#' @importFrom dplyr mutate
#' @importFrom dplyr bind_rows
#' @importFrom utils read.csv
#'
#' @export
#'
#' @examples
#' anno <- getKinaseAnnotation()
getKinaseAnnotation <- function() {
    st <- read.csv( .JohnsonKinaseAnnotation() ) |>
        dplyr::mutate(AcceptorSpecificity = 'Ser/Thr', 
                        KinaseSubType = NA,
                        .after='Description')
    
    ty <- read.csv( .TyrosineKinaseAnnotation() ) |>
        dplyr::mutate(AcceptorSpecificity = 'Tyr', 
                        .after='Description')

    dplyr::bind_rows(st, ty)
 }

#' Get precomputed PWM scores for two sets of curated human phosphosites
#'
#' Two sets of background scores are provided:
#'
#' 1. Ser/Thr phosphosites published in Johnson et al. 2023 2. Tyr phosphosites
#' published in Yaron-Barir et al. 2024
#'
#' The background scores are derived from matching the corresponding PWMs to
#' each of the sets. The resulting data frames contain the log2-odds score per
#' phosphosite and PWM.
#'
#' @param phosphoAcceptor Return background scores for either Ser/Thr or Tyr
#'   phosphosites
#'
#' @return A data frame with log2-odds scores per phosphosite (rows) and PWMs
#'   (columns)
#'
#' @references Johnson, J.L., Yaron, T.M., Huntsman, E.M. et al. An atlas of
#'   substrate specificities for the human serine/threonine kinome. Nature 613,
#'   759–766 (2023). https://doi.org/10.1038/s41586-022-05575-3
#'
#'   Yaron-Barir, T.M., Joughin, B.A., Huntsman, E.M. et al. The intrinsic
#'   substrate specificity of the human tyrosine kinome. Nature 629, 1174–1181
#'   (2024). https://doi.org/10.1038/s41586-024-07407-y
#'
#' @importFrom ExperimentHub ExperimentHub
#' @importFrom ExperimentHub createHubAccessors
#' @importFrom checkmate assert_choice
#' @importFrom utils read.csv
#'
#' @export
#'
#' @examples
#' bg <- getBackgroundScores(phosphoAcceptor='Tyr')
getBackgroundScores <- function(phosphoAcceptor = c('Ser/Thr','Tyr')) {
    
    checkmate::assert_choice(phosphoAcceptor, choices=c('Ser/Thr','Tyr'))
    
    if (phosphoAcceptor == 'Ser/Thr') {
        read.csv( .JohnsonKinaseBackgroundScores() )        
    } else {
        read.csv( .TyrosineKinaseBackgroundScores() )   
    }
}

#' processPhosphopetides
#'
#' Process phospho-peptides to a common format used for PWM matching
#'
#' Phosphorylated residues are recognized either by lower case letters (s, t or
#' y) or the phosphorylated residue is followed by an asterisk (S*, T* or Y*).
#'
#' If a peptide reports several phosphorylated residues, parameter
#' `onlyCentralAcceptor` allows for two processing options: (1) By default, only
#' the central phospho-acceptor of each phospho-peptide is considered. Here
#' central is defined as the left-closest position to `floor(nchar(site)/2)+1`.
#' (2) All phospho-acceptors are considered as central in which case the
#' phospho-peptide is replicated and aligned for each of its phosphorylated
#' residues. In this case the output sites are not in parallel to the input
#' peptides.
#'
#' In both cases, non-central phospho-acceptors are indicated by lower case
#' letters (s, t, or y). These residues enable phospho-priming of the site. If
#' phospho-priming is disabled (parameter `allowPhosphoPriming`) these residues
#' are converted to upper case letters.
#'
#' If a site does not follow the phosphorylation patterns described above, the 
#' central residue defined by position `floor(nchar(site)/2)+1` is considered 
#' the default phospho-acceptor site.
#'
#' The input sites are truncated and/or padded such that the processed sites are
#' of width `upstream`+`downstream`+1. By default the central phospho-acceptor 
#' is surrounded by 5 upstream and 5 downstream residues.
#'
#' A warning is raised if the central phospho-acceptor is not serine, threonine 
#' or tyrosine.
#'
#' @param sites Character vector with phospho-peptides
#' @param onlyCentralAcceptor Process only the central phospho-acceptor residue?
#' @param allowPhosphoPriming Allow phospho-acceptors at non-central positions?
#'   These should be indicated by the lower case letters s, t or y.
#' @param upstream Number of bases upstream of central phospho-acceptor in the 
#'   processed output
#' @param downstream Number of bases downstream of central phospho-acceptor in 
#'   the processed output
#'
#' @return A tibble with columns: `sites`, `processed`, `acceptor`
#'
#' @importFrom checkmate assert_character
#' @importFrom checkmate assert_logical
#' @importFrom tidyr tibble
#' @importFrom tidyr unnest
#' @importFrom dplyr mutate
#' @importFrom dplyr if_else
#' @importFrom dplyr group_by
#' @importFrom dplyr slice_min
#' @importFrom dplyr ungroup
#' @importFrom dplyr select
#' @importFrom dplyr full_join
#' @importFrom dplyr join_by
#' @importFrom stringr str_count
#' @importFrom stringr str_replace_all
#' @importFrom stringr str_sub
#' @importFrom stringr regex
#' @importFrom stringr str_pad
#' @importFrom stringr str_trunc
#' @importFrom stringr str_extract
#' @importFrom stringr str_c
#' @importFrom stringr str_to_upper
#' @importFrom purrr map
#'
#' @export
#'
#' @examples
#' procSites <- processPhosphopeptides(c("AGLLS*DEDC", "RtEKGS*N", "ETGKDN"))
processPhosphopeptides <- function(sites,
                                   onlyCentralAcceptor=TRUE,
                                   allowPhosphoPriming=TRUE,
                                   upstream=5L,
                                   downstream=5L) {
    
    checkmate::assert_character(sites)
    checkmate::assert_logical(allowPhosphoPriming)
    checkmate::assert_numeric(upstream, lower=0, len=1)
    checkmate::assert_numeric(downstream, lower=0, len=1)
    
    ## unify acceptor pattern
    data <- tidyr::tibble(sites) |>
        dplyr::mutate(
            modified=stringr::str_replace_all(sites, 
                                              c('[S,s]\\*'='s', '[T,t]\\*'='t', 
                                                '[Y,y]\\*'='y')),
            center_pos=floor(nchar(modified)/2) + 1,
            is_lower=stringr::str_count(modified, "[s,t,y]") > 0)
    
    ## find possible acceptor locations
    locs <- data |>
        dplyr::mutate(hits=stringr::str_locate_all(modified, "[s,t,y]"),  
                      acceptor_pos=purrr::map(hits, function(df) df[,1])) |> 
        tidyr::unnest(acceptor_pos, keep_empty=TRUE) |>
        dplyr::mutate(acceptor_pos=dplyr::if_else(is_lower, 
                                                  acceptor_pos, 
                                                  center_pos)) 
    
    if (onlyCentralAcceptor) {
        ## select left-closest acceptor to central position 
        locs <- locs |>
            dplyr::group_by(modified) |>
            dplyr::mutate(diff=abs(acceptor_pos - center_pos)) |>
            dplyr::slice_min(diff, with_ties=TRUE) |>
            dplyr::arrange(acceptor_pos) |>
            dplyr::slice_head() |>
            dplyr::ungroup()
    }
    
    data <- data |>
        dplyr::full_join(locs |> dplyr::select(modified, acceptor_pos),
                         by = dplyr::join_by(modified))
    
    ## split sites in left and right parts
    data <- data |>
        dplyr::mutate(left=stringr::str_sub(modified, 
                                            end=acceptor_pos),
                      right=stringr::str_sub(modified, 
                                             start=acceptor_pos+1))
                      
    ## pad left/right parts to match upstream/downstream conditions
    data <- data |>
        dplyr::mutate(left=stringr::str_pad(left, pad='_', 
                                            width=upstream+1, side="left"),
                      left=stringr::str_trunc(left, width=upstream+1, 
                                              side="left", ellipsis=""),
                      right=stringr::str_pad(right, pad='_', 
                                             width=downstream, side="right"),
                      right=stringr::str_trunc(right, width=downstream, 
                                               side="right", ellipsis=""),
                      processed=stringr::str_c(left,right), 
                      acceptor=stringr::str_to_upper(
                          stringr::str_sub(processed, 
                                           start=upstream+1, 
                                           end=upstream+1)))
    
    stringr::str_sub(data$processed, start=upstream+1, end=upstream+1) <- 
        (data |> dplyr::pull(acceptor))
    
    if (any(!data$acceptor %in% c('S','T','Y')))
        warning('No S/T/Y at central phospho-acceptor position.')
    
    if (!allowPhosphoPriming) {
        data <- data |> 
            dplyr::mutate(processed=stringr::str_to_upper(processed)) 
    }
    
    data |> dplyr::select(sites, processed, acceptor)
}

# A script to make the metadata.csv file located in inst/extdata of the package.
library(HubPub)
library(here)
   
here::i_am('inst/scripts/make-metadata.R')

metadata_path <- file.path(here::here('inst','extdata'), "metadata.csv")
writeLines(paste(names(hub_metadata()), collapse = ","), 
           metadata_path)

# Ser/Thr kinase data published in Johnson et al. 2023

# Ser/Thr kinase annotation
metadata <- HubPub::hub_metadata(
  Title = "JohnsonKinaseAnnotation",
  Description = "Annotation data for each ser/thr kinase PWM published in Johnson et al. 2023",
  BiocVersion = "3.20",
  Genome = NA_character_,
  SourceType = "XLS/XLSX",
  SourceUrl = "https://static-content.springer.com/esm/art%3A10.1038%2Fs41586-022-05575-3/MediaObjects/41586_2022_5575_MOESM3_ESM.xlsx",
  SourceVersion = "31.01.2024",
  Species = "Homo sapiens",
  TaxonomyId = as.integer(9606),
  Coordinate_1_based = NA,
  DataProvider = "Nature publishing group",
  Maintainer = "Florian Geier <florian.geier@unibas.ch>",
  RDataClass = "character",
  DispatchClass = "FilePath",
  Location_Prefix = "https://zenodo.org/",
  RDataPath = "records/10628874/files/JohnsonKinaseAnnotation.csv",
  Tags = "Proteomics:Phosohosite:Serine/Threonine:Kinase activity:Position weight matrix:PWM"
)

HubPub::add_resource(here::here(), metadata)

# Ser/Thr kinase PWMs
metadata <- HubPub::hub_metadata(
  Title = "JohnsonKinasePWM",
  Description = "List of Ser/Thr kinase position weight matrices (PWMs) published in Johnson et al. 2023",
  BiocVersion = "3.20",
  Genome = NA_character_,
  SourceType = "XLS/XLSX",
  SourceUrl = "https://static-content.springer.com/esm/art%3A10.1038%2Fs41586-022-05575-3/MediaObjects/41586_2022_5575_MOESM4_ESM.xlsx",
  SourceVersion = "31.01.2024",
  Species = "Homo sapiens",
  TaxonomyId = as.integer(9606),
  Coordinate_1_based = NA,
  DataProvider = "Nature publishing group",
  Maintainer = "Florian Geier <florian.geier@unibas.ch>",
  RDataClass = "character",
  DispatchClass = "FilePath",
  Location_Prefix = "https://zenodo.org/",
  RDataPath = "records/10628874/files/JohnsonKinasePWM.csv.gz",
  Tags = "Proteomics:Phosohosite:Serine/Threonine:Kinase activity:Position weight matrix:PWM"
)

HubPub::add_resource(here::here(), metadata)

# Ser/Thr kinase background scores
metadata <- HubPub::hub_metadata(
  Title = "JohnsonKinaseBackgroundScores",
  Description = "Matrix of PWM scores on a set of background phosphosites published in Johnson et al. 2023",
  BiocVersion = "3.20",
  Genome = NA_character_,
  SourceType = "XLS/XLSX",
  SourceUrl = "https://static-content.springer.com/esm/art%3A10.1038%2Fs41586-022-05575-3/MediaObjects/41586_2022_5575_MOESM5_ESM.xlsx",
  SourceVersion = "31.01.2024",
  Species = "Homo sapiens",
  TaxonomyId = as.integer(9606),
  Coordinate_1_based = NA,
  DataProvider = "Nature publishing group",
  Maintainer = "Florian Geier <florian.geier@unibas.ch>",
  RDataClass = "character",
  DispatchClass = "FilePath",
  Location_Prefix = "https://zenodo.org/",
  RDataPath = "records/10628874/files/JohnsonKinaseBackgroundScores.csv.gz",
  Tags = "Proteomics:Phosohosite:Serine/Threonine:Kinase activity:Position weight matrix:PWM"
)

HubPub::add_resource(here::here(), metadata)

# Ser/Thr kinase background score quantiles
metadata <- HubPub::hub_metadata(
  Title = "JohnsonKinaseBackgroundQuantiles",
  Description = "Matrix of PWM score quantiles on a set of background phosphosites published in Johnson et al. 2023",
  BiocVersion = "3.20",
  Genome = NA_character_,
  SourceType = "XLS/XLSX",
  SourceUrl = "https://static-content.springer.com/esm/art%3A10.1038%2Fs41586-022-05575-3/MediaObjects/41586_2022_5575_MOESM5_ESM.xlsx",
  SourceVersion = "31.01.2024",
  Species = "Homo sapiens",
  TaxonomyId = as.integer(9606),
  Coordinate_1_based = NA,
  DataProvider = "Nature publishing group",
  Maintainer = "Florian Geier <florian.geier@unibas.ch>",
  RDataClass = "character",
  DispatchClass = "FilePath",
  Location_Prefix = "https://zenodo.org/",
  RDataPath = "records/10628874/files/JohnsonKinaseBackgroundQuantiles.csv.gz",
  Tags = "Proteomics:Phosohosite:Serine/Threonine:Kinase activity:Position weight matrix:PWM"
)

HubPub::add_resource(here::here(), metadata)

## Tyrosine kinase data published in Yaron-Barir et al. 2024

# Tyr kinase annotation
metadata <- HubPub::hub_metadata(
    Title = "TyrosineKinaseAnnotation",
    Description = "Annotation data for each tyrosine kinase PWM published in Yaron-Barir et al. 2024",
    BiocVersion = "3.20",
    Genome = NA_character_,
    SourceType = "XLS/XLSX",
    SourceUrl = "https://static-content.springer.com/esm/art%3A10.1038%2Fs41586-024-07407-y/MediaObjects/41586_2024_7407_MOESM3_ESM.xlsx",
    SourceVersion = "16.09.2024",
    Species = "Homo sapiens",
    TaxonomyId = as.integer(9606),
    Coordinate_1_based = NA,
    DataProvider = "Nature publishing group",
    Maintainer = "Florian Geier <florian.geier@unibas.ch>",
    RDataClass = "character",
    DispatchClass = "FilePath",
    Location_Prefix = "https://zenodo.org/",
    RDataPath = "records/13831966/files/TyrosineKinaseAnnotation.csv",
    Tags = "Proteomics:Phosohosite:Tyrosine:Kinase activity:Position weight matrix:PWM"
)

HubPub::add_resource(here::here(), metadata)

# Tyr kinase PWMs
metadata <- HubPub::hub_metadata(
    Title = "TyrosineKinasePWM",
    Description = "List of tyrosine kinase position weight matrices (PWMs) published in Yaron-Barir et al. 2024",
    BiocVersion = "3.20",
    Genome = NA_character_,
    SourceType = "XLS/XLSX",
    SourceUrl = "https://static-content.springer.com/esm/art%3A10.1038%2Fs41586-024-07407-y/MediaObjects/41586_2024_7407_MOESM4_ESM.xlsx",
    SourceVersion = "16.09.2024",
    Species = "Homo sapiens",
    TaxonomyId = as.integer(9606),
    Coordinate_1_based = NA,
    DataProvider = "Nature publishing group",
    Maintainer = "Florian Geier <florian.geier@unibas.ch>",
    RDataClass = "character",
    DispatchClass = "FilePath",
    Location_Prefix = "https://zenodo.org/",
    RDataPath = "records/13831966/files/TyrosineKinasePWM.csv.gz",
    Tags = "Proteomics:Phosohosite:Tyrosine:Kinase activity:Position weight matrix:PWM"
)

HubPub::add_resource(here::here(), metadata)

# Tyr kinase background scores
metadata <- HubPub::hub_metadata(
    Title = "TyrosineKinaseBackgroundScores",
    Description = "Matrix of PWM scores on a set of background phosphosites published in Yaron-Barir et al. 2024",
    BiocVersion = "3.20",
    Genome = NA_character_,
    SourceType = "XLS/XLSX",
    SourceUrl = "https://static-content.springer.com/esm/art%3A10.1038%2Fs41586-024-07407-y/MediaObjects/41586_2024_7407_MOESM5_ESM.xlsx",
    SourceVersion = "16.09.2024",
    Species = "Homo sapiens",
    TaxonomyId = as.integer(9606),
    Coordinate_1_based = NA,
    DataProvider = "Nature publishing group",
    Maintainer = "Florian Geier <florian.geier@unibas.ch>",
    RDataClass = "character",
    DispatchClass = "FilePath",
    Location_Prefix = "https://zenodo.org/",
    RDataPath = "records/13831966/files/TyrosineKinaseBackgroundScores.csv.gz",
    Tags = "Proteomics:Phosohosite:Tyrosine:Kinase activity:Position weight matrix:PWM"
)

HubPub::add_resource(here::here(), metadata)

# Tyr kinase background score quantiles
metadata <- HubPub::hub_metadata(
    Title = "TyrosineKinaseBackgroundQuantiles",
    Description = "Matrix of PWM score quantiles on a set of background phosphosites published in Yaron-Barir et al. 2024",
    BiocVersion = "3.20",
    Genome = NA_character_,
    SourceType = "XLS/XLSX",
    SourceUrl = "https://static-content.springer.com/esm/art%3A10.1038%2Fs41586-024-07407-y/MediaObjects/41586_2024_7407_MOESM5_ESM.xlsx",
    SourceVersion = "16.09.2024",
    Species = "Homo sapiens",
    TaxonomyId = as.integer(9606),
    Coordinate_1_based = NA,
    DataProvider = "Nature publishing group",
    Maintainer = "Florian Geier <florian.geier@unibas.ch>",
    RDataClass = "character",
    DispatchClass = "FilePath",
    Location_Prefix = "https://zenodo.org/",
    RDataPath = "records/13831966/files/TyrosineKinaseBackgroundQuantiles.csv.gz",
    Tags = "Proteomics:Phosohosite:Tyrosine:Kinase activity:Position weight matrix:PWM"
)

HubPub::add_resource(here::here(), metadata)

#' Get a list of position specific weight matrices (PWMs) for human kinases
#'
#' The function returns a named list of 396 kinase PWMs. Among these are 303
#' serine/threonine kinases, 78 canonical tyrosine kinases and 15 non-canonical
#' tyrosine kinases i.e. dual-specific kinases, indicated by the '_TYR' suffix.
#'
#' Each PWM stores the log2-odds score per amino acid (23 rows) and position (10
#' or 11 columns) in matrix format. Beside the 20 standard amino acids also
#' phosphorylated serine, threonine and tyrosine residues are included.
#'
#' The central phospho-acceptor position of each PWM is at position `0` (column
#' 6). For serine/threonine specific kinases this position quantifies the
#' favorability of serine over threonine, but can be omitted when setting
#' 'includeSTfavorability=FALSE'.
#'
#' The specificity of a kinase PWM is controlled by parameter
#' 'matchAcceptorSpecificity'. If set to 'TRUE', sites without a matching
#' acceptor are scored with '-Inf'.
#'
#' @param includeSTfavorability Include serine vs. threonine favorability for
#'   the central phospho-acceptor?
#'
#' @param matchAcceptorSpecificity Only score sites with a matching central
#'   phospho-acceptor?
#'
#' @return A named list of numeric matrices (PWMs).
#'
#' @importFrom checkmate assert_logical
#' @importFrom dplyr mutate
#' @importFrom dplyr pull
#' @importFrom dplyr select
#' @importFrom tidyr pivot_wider
#'
#' @export
#'
#' @references Johnson, J.L., Yaron, T.M., Huntsman, E.M. et al. An atlas of
#'   substrate specificities for the human serine/threonine kinome. Nature 613,
#'   759–766 (2023). https://doi.org/10.1038/s41586-022-05575-3
#'
#'   Yaron-Barir, T.M., Joughin, B.A., Huntsman, E.M. et al. The intrinsic
#'   substrate specificity of the human tyrosine kinome. Nature 629, 1174–1181
#'   (2024). https://doi.org/10.1038/s41586-024-07407-y
#'
#' @examples
#' pwms <- getKinasePWM()
getKinasePWM <- function(includeSTfavorability=TRUE,
                         matchAcceptorSpecificity=FALSE) {
  
    checkmate::assert_logical(includeSTfavorability)
    checkmate::assert_logical(matchAcceptorSpecificity)
    
    .convert_to_matrix <- function(x,
                                   includeSTfavorability=TRUE,
                                   acceptorSpecificity=NULL) {
        x <- x |> 
            dplyr::select(-Matrix) |> 
            tidyr::pivot_wider(values_from=Score, 
                               names_from=Position) 
        y <- as.matrix(x |> dplyr::select(-AA))
        rownames(y) <- x |> dplyr::pull(AA)
        if (!includeSTfavorability)
            y[c('S','T'),'0'] <- NA_real_
        y
        if (!is.null(acceptorSpecificity))
            y[setdiff(rownames(y), acceptorSpecificity),'0'] <- -Inf
        y
    }
    
    pwm <- read.csv( .JohnsonKinasePWM() )
    st <- lapply(split(pwm, pwm$Matrix), .convert_to_matrix, 
                 includeSTfavorability=includeSTfavorability,
                 acceptorSpecificity=if (matchAcceptorSpecificity) c('S','T','s','t')
                 )

    pwm <- read.csv( .TyrosineKinasePWM() )
    ty <- lapply(split(pwm, pwm$Matrix), .convert_to_matrix, 
                 includeSTfavorability=FALSE,
                 acceptorSpecificity=if (matchAcceptorSpecificity) c('Y','y')
    )
    
    c(st, ty)
}

#' Map log2-odds score to percentile rank
#'
#' For each kinase PWM, get a function that maps its log2-odds score to the
#' percentile rank in the background score distribution. The percentile rank of
#' a given score is the percentage of scores in corresponding background score
#' distribution that are less than or equal to that score. The background score
#' distribution per PWM is derived from matching each PWM to either the 85'603
#' unique phosphosites published in Johnson et al. 2023 (serine/threonine PWMs)
#' or the 6659 unique phosphosites published in Yaron-Barir et al. 2024
#' (tyrosine PWMs).
#'
#' Note: since the background sites don't contain non-central phosphorylated
#' residues (phospho-priming), the percentile rank of an input site which
#' includes phospho-priming will be capped to 100, if its PWM score exceeds the
#' largest observed background score for that PWM.
#'
#' Internally, [stats::approxfun] is used to linearly interpolate between the
#' PWM score and its 0.1% - quantile in the distribution over background scores.
#' This approximation allows for a lower memory footprint compared with the full
#' set of background scores.
#'
#' @return A named list of functions, one for each kinase PWM. Each function is
#'   taking a vector of log2-odds scores as input and returns the corresponding
#'   percentile ranks.
#'
#' @importFrom stats approxfun
#'
#' @export
#'
#' @examples
#' maps <- getScoreMaps()
getScoreMaps <- function() {
    PR <- cbind(
        read.csv( .JohnsonKinaseBackgroundQuantiles() ),
        read.csv( .TyrosineKinaseBackgroundQuantiles() )[,-1]
    )
    lapply(PR[,-1], function(score, quant) {
        stats::approxfun(score, quant, 
                         yleft=0, yright=100, 
                         ties=min)
    }, quant = 100 * PR[,"Quantiles"])
}


#' Low level single PWM scoring function. All unmatched characters (like "_" or
#' ".") evaluate to NA and don't contribute to the score sum. All strings must
#' be left aligned with the PWM. Characters extending the width of the PWM are 
#' excluded.
#' @noRd
.scoreSinglePWM <- function(sites, pwm) {
    vapply(sites, 
           FUN=function(aa) {
               aa <- aa[seq_len(ncol(pwm))]
               aa_score <- pwm[cbind(base::match(aa,rownames(pwm)), 
                                     seq_along(aa))]
               sum(aa_score, na.rm=TRUE) 
           }, 
           NA_real_)
}

#' Low level multiple PWM scoring function
#' @noRd
.scoreMultiplePWM <- function(sites, pwms, BPPARAM) {
    BiocParallel::bplapply(
        pwms,
        FUN=function(pwm, sites) {
            .scoreSinglePWM(sites, pwm)
        },
        sites=sites,
        BPPARAM=BPPARAM
    )
}

#' log2-odds to percentile rank
#' @noRd
.lodToPR <- function(scores, scoreMaps, BPPARAM) {
    BiocParallel::bpmapply(
        FUN=function(score, scoreMap) {
            scoreMap(score)
        },
        scores,
        scoreMaps[names(scores)],
        SIMPLIFY=FALSE,
        USE.NAMES=TRUE,
        BPPARAM=BPPARAM)
}

#' Match kinase PWMs to processed phosphosites
#'
#' `scorePhosphosites` takes a list of kinase PWMs and a vector of processed
#' phosphosites as input and returns a matrix of match scores per PWM and site.
#'
#' The match score is either the log2-odds score (`lod`) or the percentile rank
#' (`percentile`) in the background score distribution.
#'
#' @param pwms List with kinase PWMs as returned by [getKinasePWM].
#' @param sites A character vector with phosphosites. Check
#'   [processPhosphopeptides] for the correct phosphosite format.
#' @param scoreType Log2-odds score or percentile rank.
#' @param BPPARAM A [BiocParallelParam] object specifying how parallelization
#'   should be performed.
#'
#' @return A numeric matrix of size `length(sites)` times `length(pwms)`.
#'
#' @importFrom checkmate assert_list
#' @importFrom checkmate assert_character
#' @importFrom checkmate assert_class
#' @importFrom BiocParallel bplapply
#' @importFrom BiocParallel SerialParam
#'
#' @export
#'
#' @seealso [getKinasePWM] for getting a list of kinase PWMs,
#'   [processPhosphopeptides] for the correct phosphosite format, and
#'   [getScoreMaps] for mapping PWM scores to percentile ranks
#'
#' @examples
#' score <- scorePhosphosites(getKinasePWM(), c("TGRRHTLAEV", "LISAVSPEIR"))
scorePhosphosites <- function(pwms, sites, 
                              scoreType=c('lod', 'percentile'), 
                              BPPARAM=BiocParallel::SerialParam()) {
    
    checkmate::assert_list(pwms, types=c("numeric", "matrix"), 
                           unique=TRUE, any.missing=FALSE, names='named')
    
    checkmate::assert_character(sites)
    
    scoreType <- match.arg(scoreType)
    
    checkmate::assert_class(BPPARAM, "BiocParallelParam")
    
    splitted <- strsplit(sites, split="")
    
    scores <- .scoreMultiplePWM(splitted, pwms, BPPARAM)
    
    if (scoreType == "percentile") {
        scoreMaps <- getScoreMaps()
        
        if (!all(names(scores) %in% names(scoreMaps))) {
            stop('Not all PWMs have score maps!')
        } 
        
        scores <- .lodToPR(scores, scoreMaps, BPPARAM)
    }
    
    scores <- do.call(cbind, scores)
    dimnames(scores) <- list(sites, names(pwms))
    
    scores
}

test_that("get kinase PWMs", {
  expect_type(getKinasePWM(), "list")
})

test_that("process phospho-peptides", {
  expect_s3_class(processPhosphopeptides(c("SAGLLS*DEDC")), "data.frame")
})

test_that("score phosphosites", {
  expect_type(scorePhosphosites(getKinasePWM(), 'TGRRHTLAEV'), "double")
})

---
title: "Download and preprocess the supplemental tables in Yaron-Barir et al. 2024 (doi:10.1038/s41586-024-07407-y)"
author: "Florian Geier"
date: "16.September.2024"
output: html_document
---

```{r setup, include=FALSE}
knitr::opts_chunk$set(echo = TRUE)
options(width = 100)
```

```{r setup}
library(here) # set relative locations

library(readxl) # read raw data (excel files)
library(dplyr)
library(tidyr)
library(stringr)

library(Homo.sapiens) # add kinase gene annotations
```

## Download raw data

```{r download_data}
here::i_am('inst/scripts/make-data-Y.Rmd')

download.file(url='https://static-content.springer.com/esm/art%3A10.1038%2Fs41586-024-07407-y/MediaObjects/41586_2024_7407_MOESM3_ESM.xlsx',
              destfile=here::here('inst','extdata','41586_2024_7407_MOESM3_ESM.xlsx'))

download.file(url='https://static-content.springer.com/esm/art%3A10.1038%2Fs41586-024-07407-y/MediaObjects/41586_2024_7407_MOESM4_ESM.xlsx', 
              destfile=here::here('inst','extdata','41586_2024_7407_MOESM4_ESM.xlsx'))

download.file(url='https://static-content.springer.com/esm/art%3A10.1038%2Fs41586-024-07407-y/MediaObjects/41586_2024_7407_MOESM5_ESM.xlsx',
              destfile=here::here('inst','extdata','41586_2024_7407_MOESM5_ESM.xlsx'))
```

## Kinase annotation

- Extract annotation for each kinase matrix and add Entrez ID and gene descriptions from Bioc annotation databases.

- Fix a couple of wrong gene symbols by hand

```{r kinase_annotation}
anno <- readxl::read_excel(here::here('inst','extdata','41586_2024_7407_MOESM3_ESM.xlsx'), 
                           sheet='Table_S1_Data')
anno <- anno |>
  dplyr::filter(Species %in% c('human','Tribolium castaneum') & !is.na(UNIPROT_ID)) |> # kinase PWM available 
  dplyr::mutate(MatrixName = MATRIX_NAME,
                UniprotID = UNIPROT_ID,
                GeneName = GENENAME,
                KinaseSubType = SUBTYPE,
                KinaseFamily = FAMILY) |>
  dplyr::select(MatrixName, GeneName, UniprotID, KinaseSubType, KinaseFamily) 

## correct by hand wrong entries
anno$GeneName[anno$GeneName == "IRR"] <- "INSRR" # insulin receptor related receptor
anno$MatrixName[anno$GeneName == "MST1R"] <- "MST1R" ## wrong MatrixName (RON)
anno$GeneName[anno$GeneName == "MKK4"] <- "MAP2K4" # mitogen-activated protein kinase kinase 
anno$GeneName[anno$GeneName == "MKK6"] <- "MAP2K6"
anno$GeneName[anno$GeneName == "MKK7"] <- "MAP2K7"
anno$GeneName[anno$GeneName == "PDHK1"] <- "PDK1" # pyruvate dehydrogenase kinase 
anno$GeneName[anno$GeneName == "PDHK3"] <- "PDK3"
anno$GeneName[anno$GeneName == "PDHK4"] <- "PDK4"

## add '_TYR' to non-canonical TK MatrixName
anno <- anno |> 
    dplyr::mutate(MatrixName = ifelse(KinaseSubType == 'ncTK', paste0(MatrixName, '_TYR'), MatrixName))  

## add EntrezID and gene description
sel <- AnnotationDbi::select(Homo.sapiens, 
                             keys = anno |> dplyr::pull(GeneName), 
                             keytype = "SYMBOL", 
                             columns = c("GENEID","GENENAME"))
## remove wrong gene for symbol TEC
sel <- sel[!sel$GENEID == "100124696",] 

df <- anno |> 
  dplyr::left_join(sel, by = join_by(GeneName == SYMBOL)) |>
  dplyr::rename(Description = GENENAME, EntrezID = GENEID) |>
  dplyr::relocate(EntrezID, Description, .after = UniprotID)

write.csv(df, 
          file = here::here('inst','extdata','TyrosineKinaseAnnotation.csv'), 
          row.names = FALSE)
```

## Process tyrosine kinase matrices

- PWMs are taken from `tyrosine_all_norm_scaled_matric` sheet.

- The PWMs contain lower case letters for phosphorylated, non-central S/T/Y residues.

```{r process_pwm}
data_scaled <- readxl::read_excel(here::here('inst','extdata','41586_2024_7407_MOESM4_ESM.xlsx'),
                                  sheet='tyrosine_all_norm_scaled_matric') |>
  dplyr::rename(Matrix = 1) |> 
  tidyr::pivot_longer(cols = -Matrix,
                      names_to = "Position",
                      values_to = "Score") |>
  tidyr::separate_wider_regex(cols = "Position", 
                              patterns = c(Position = "[^A-z]+", 
                                           AA = "[A-z]+")) |>
  dplyr::mutate(Position = factor(Position, ## add central acceptor position
                                  levels=seq(-5,5))) |> 
  tidyr::complete(Matrix, Position, AA, fill=list(Score=NA_real_)) 
    
PWM <- data_scaled |> 
  dplyr::mutate(Score = log2(Score),
                Position = as.integer(as.character(Position))) |>
  dplyr::arrange(Matrix, Position, AA)

write.csv(PWM, 
          file = gzfile(here::here('inst','extdata','TyrosineKinasePWM.csv.gz')), 
          row.names = FALSE)
```

## PWM background scores

- Background peptide sequences are taken from the `SITE_+/-7_AA`
  column of the corresponding excel sheet, and the central 11 AA are
  extracted (central phosphosite at position 6)

- Next, all kinase PWMs defined above are matched against all unique
  background peptides

- The resulting score vectors are combine into a data frame and saved.

```{r background_scores}
background <- readxl::read_excel(here::here('inst','extdata',"41586_2024_7407_MOESM5_ESM.xlsx"),
                                 sheet=2)

sites <- background |>
  dplyr::mutate(sites = stringr::str_sub(background$`SITE_+/-7_AA`, start = 3, end = 13)) |>
  dplyr::pull(sites) |>
  unique()

length(sites) # reported in paper: 7,315 but is 6659 unique sites in the table

source(here::here('R','score_phosphosites.R')) # functionality to score sites

pwms <- read.csv(here::here('inst','extdata','TyrosineKinasePWM.csv.gz'))
PWM <- lapply(split(pwms, pwms$Matrix), function(x) {
    x <- x |> 
        dplyr::select(-Matrix) |> 
        tidyr::pivot_wider(values_from=Score, 
                           names_from=Position) 
    y <- as.matrix(x |> dplyr::select(-AA))
    rownames(y) <- x |> dplyr::pull(AA)
    y
})
    
scores <- scorePhosphosites(PWM, sites, scoreType = 'lod')
  
write.csv(data.frame(PhosphoSite = sites, scores), 
          file = gzfile(here::here('inst','extdata','TyrosineKinaseBackgroundScores.csv.gz')),
          row.names = FALSE)

## compute quantiles
probs <- seq(0,1,length.out=1001)
quants <- sapply(colnames(scores), function(x)  quantile(scores[,x], probs))
write.csv(data.frame(Quantiles = probs, quants), 
          file = gzfile(here::here('inst','extdata','TyrosineKinaseBackgroundQuantiles.csv.gz')), 
          row.names = FALSE)
```

## Session information

```{r session_info}
sessionInfo()
```

---
title: "Download and preprocess the supplemental tables in Johnson et al. 2023 (doi:10.1038/s41586-022-05575-3)"
author: "Florian Geier"
date: "31.Jan.2024"
output: html_document
---

```{r setup, include=FALSE}
knitr::opts_chunk$set(echo = TRUE)
options(width = 100)
```

```{r}
library(here) # set relative locations

library(readxl) # read raw data (excel files)
library(dplyr)
library(tidyr)
library(stringr)

library(Homo.sapiens) # add kinase gene annotations
```

## Download raw data

```{r}
here::i_am('inst/scripts/make-data.Rmd')

download.file(url = 'https://static-content.springer.com/esm/art%3A10.1038%2Fs41586-022-05575-3/MediaObjects/41586_2022_5575_MOESM3_ESM.xlsx', 
              destfile = here::here('inst','extdata','41586_2022_5575_MOESM3_ESM.xlsx'))

download.file(url = 'https://static-content.springer.com/esm/art%3A10.1038%2Fs41586-022-05575-3/MediaObjects/41586_2022_5575_MOESM4_ESM.xlsx',
              destfile = here::here('inst','extdata','41586_2022_5575_MOESM4_ESM.xlsx'))

download.file(url = 'https://static-content.springer.com/esm/art%3A10.1038%2Fs41586-022-05575-3/MediaObjects/41586_2022_5575_MOESM5_ESM.xlsx',
              destfile = here::here('inst','extdata','41586_2022_5575_MOESM5_ESM.xlsx'))
```

## Kinase annotation

- Extract annotation for each kinase matrix and add Entrez ID and gene descriptions 
  from Bioc annotation databases

```{r}
anno <- readxl::read_excel(here::here('inst','extdata','41586_2022_5575_MOESM3_ESM.xlsx'), 
                           sheet='Table S1 Data')
anno <- anno |>
  dplyr::mutate(MatrixName = Matrix_name,
                UniprotID = `Uniprot id`,
                GeneName = Gene,
                KinaseFamily = Family) |>
  dplyr::select(MatrixName, GeneName, UniprotID, KinaseFamily) 

## add EntrezID and gene description
sel <- AnnotationDbi::select(Homo.sapiens, 
                             keys = anno |> dplyr::pull(GeneName), 
                             keytype = "SYMBOL", 
                             columns = c("GENEID","GENENAME"))
# 1:1
df <- anno |> 
  dplyr::full_join(sel, by = join_by(GeneName == SYMBOL)) |>
  dplyr::rename(Description = GENENAME, EntrezID = GENEID) |>
  dplyr::relocate(EntrezID, Description, .after = UniprotID)

write.csv(df, 
          file = here::here('inst','extdata','JohnsonKinaseAnnotation.csv'), 
          row.names = FALSE)
```

## Process kinase matrices

- PWMs are taken from `ser_thr_all_norm_scaled_matrice` sheet.

- For each kinase matrix, the phospho-acceptor favourability is calculated from the raw data (`ser_thr_all_raw_matrices` sheet) as described in the supplement of Johnson et al. 2023.

- The S/T favourability is added to each matrix at the central position (position 0) and all values are converted to log2-odds.

- The PWMs contain lower case letters for phosphorylated, non-central S/T/Y residues.

```{r}
## only used to calculate phospho-acceptor favourability
data_raw <- readxl::read_excel((here::here('inst','extdata','41586_2022_5575_MOESM4_ESM.xlsx')),
                               sheet = 'ser_thr_all_raw_matrices') |>
  dplyr::rename(Matrix = 1) |> 
  tidyr::pivot_longer(cols = -Matrix,
                      names_to = "Position",
                      values_to = "Score") |>
  tidyr::separate_wider_regex(cols = "Position", 
                              patterns = c(Position = "[^A-z]+", 
                                           AA = "[A-z]+")) 

ST_fav <- data_raw |> 
  dplyr::filter(AA %in% c('S','T')) |>
  dplyr::group_by(Matrix, AA) |> 
  dplyr::summarize(Total = sum(Score)) |>
  tidyr::pivot_wider(values_from = Total, names_from = AA) |>
  dplyr::mutate(Sctrl = 0.75 * S - 0.25 * T,
                Tctrl = 0.75 * T - 0.25 * S,
                S = Sctrl/max(c(Sctrl, Tctrl)),
                T = Tctrl/max(c(Sctrl, Tctrl))) |>
  dplyr::select(Matrix, S, T) |>
  tidyr::pivot_longer(cols = -Matrix,
                      names_to = "AA",
                      values_to = "Score") |>
  dplyr::mutate(Position = 0) |> ungroup()

## load scaled data (odds)
data_scaled <- readxl::read_excel(here::here('inst','extdata','41586_2022_5575_MOESM4_ESM.xlsx'),
                                  sheet='ser_thr_all_norm_scaled_matrice') |>
  dplyr::rename(Matrix = 1) |> 
  tidyr::pivot_longer(cols = -Matrix,
                      names_to = "Position",
                      values_to = "Score") |>
  tidyr::separate_wider_regex(cols = "Position", 
                              patterns = c(Position = "[^A-z]+", 
                                           AA = "[A-z]+")) |>
  dplyr::mutate(Position = as.integer(Position)) # 

## merge with S/T favourability odds and convert to log2 odd score
PWM <- data_scaled |> 
  dplyr::full_join(ST_fav) |>
  dplyr::mutate(Score = log2(Score)) |>
  dplyr::arrange(Matrix, Position, AA)

write.csv(PWM, 
          file = gzfile(here::here('inst','extdata','JohnsonKinasePWM.csv.gz')), 
          row.names = FALSE)
```

## PWM background scores

- Background peptide sequences are taken from the `SITE_+/-7_AA`
  column of the corresponding excel sheet, and the central 10 AA are
  extracted (central phosphosite at position 6)

- Next, all kinase PWMs defined above are matched against all unique
  background peptides

- The resulting score vectors are combine into a data frame and saved.

```{r}
background <- readxl::read_excel(here::here('inst','extdata',"41586_2022_5575_MOESM5_ESM.xlsx"),
                                 sheet='Supplementary Table 3')

sites <- background |>
  dplyr::mutate(sites = stringr::str_sub(background$`SITE_+/-7_AA`, start = 3, end = 12)) |>
  dplyr::pull(sites) |>
  unique()

length(sites) # reported in paper: 82,735 but is 85,603 unique sites in the table

source(here::here('R','score_phosphosites.R')) # functionality to score sites

PWM <- getKinasePWM()
scores <- scorePhosphosites(PWM, sites, scoreType = 'lod')
  
write.csv(data.frame(PhosphoSite = sites, scores), 
          file = gzfile(here::here('inst','extdata','JohnsonKinaseBackgroundScores.csv.gz')),
          row.names = FALSE)

## compute quantiles
probs <- seq(0,1,length.out=1001)
quants <- sapply(colnames(scores), function(x)  quantile(scores[,x], probs))
write.csv(data.frame(Quantiles = probs, quants), 
          file = gzfile(here::here('inst','extdata','JohnsonKinaseBackgroundQuantiles.csv.gz')), 
          row.names = FALSE)
```

## Notes 

- While the PWMs can match phosphorylated, non-central S/T/Y residues by lower case letters, the background sites do not contain any of these cases. Since the contribution of phosphorylated, non-central S/T/Y residues to the total PWM score can be quite substantial, the largest observed background score is in all cases smaller than the maximal PWM score. As a consequence, mapping the PWM score to its percentile rank will cap the score to the maximum of the background and not take phosphorylated, non-central S/T/Y residues into account.

## Session information

```{}
sessionInfo()
```

```{r, echo=FALSE, eval=FALSE}
## try to infer PWMs from raw data; not used due to missing information

# The densitometry matrices were column-normalized at all positions by the sum of the 17 randomized amino acids (excluding serine, threonine and cysteine), to yield PSSMs (Supplementary Table 2). PDHK1 and PDHK4 were normalized to the 16 randomized amino acids (excluding serine, threonine, cysteine and additionally tyrosine), corresponding to the uniquely customized peptide library that profiled these kinases. 
data_norm <- data_raw |>
  dplyr::group_by(Matrix, Position) |>
  dplyr::mutate(Total1 = sum(dplyr::if_else(AA %in% c('S','T','C','t','s','y'), 0, Score)),
                Total2 = sum(dplyr::if_else(AA %in% c('S','T','C','Y','s','t','y'), 0, Score)),
                Normalized = dplyr::if_else(Matrix %in% c('PDHK1','PDHK4'), Score/Total2, Score/Total1)) |>
  dplyr::ungroup()

# The cysteine row was scaled by its median to be 1/17 (1/16 for PDHK1 and PDHK4). 
data_norm <- data_norm |>
  dplyr::group_by(Matrix, AA) |>
  dplyr::mutate(med = median(Normalized),
                Normalized = dplyr::case_when(AA == 'C' ~ Normalized/17/med, 
                                              Matrix %in% c('PDHK1','PDHK4') & AA == 'C' ~ Normalized/16/med,
                                              .default = Normalized)) |>
  dplyr::ungroup()

# The serine and threonine values in each position were set to be the median of that position. ??? seems not correct!
data_norm <- data_norm |>
  dplyr::group_by(Matrix, Position) |>
  # dplyr::mutate(med_ST = median(dplyr::if_else(AA %in% c('S','T'), Normalized, NA), na.rm = TRUE),
  #               Normalized = dplyr::if_else(AA %in% c('S','T'), med_ST, Normalized))
  dplyr::mutate(Normalized = dplyr::if_else(AA %in% c('S','T'), median(Normalized), Normalized))
  
data_norm |> dplyr::filter(AA %in% c("S","T") & Position == -5)  

## all values are "scaled to random frequency of amino acids" to get the final PWMs (without phospho-acceptor favourability). What is the random frequency of amino acids used?
```

---
title: "Using JohnsonKinaseData to predict kinase-substrate relationships"
author: "Florian Geier"
date: "`r BiocStyle::doc_date()`"
package: "`r BiocStyle::pkg_ver('JohnsonKinaseData')`"
output: 
  BiocStyle::html_document:
    toc_float: true
vignette: >
  %\VignetteIndexEntry{JohnsonKinaseData}
  %\VignetteEncoding{UTF-8}
  %\VignetteEngine{knitr::rmarkdown}
editor_options: 
  chunk_output_type: console
bibliography: JohnsonKinaseData.bib
---

```{r include = FALSE}
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>"
)
```

# Introduction

The `r Biocpkg("JohnsonKinaseData")` package provides substrate affinities in the form of position-specific weight matrices (PWMs) for 396 human kinases originally published in Johnson et al. [@Johnson2023] and Yaron-Barir et al. [@Yaron-Barir2024]. It includes basic functionality to pre-process user-provided phosphopetides and match them against all kinase PWMs. The aim is to give the user a simple way of predicting kinase-substrate relationships based on PWM-phosphosite matching. These predictions can serve to infer kinase activity from differential phospho-proteomic data. 

# Installation

The `r Biocpkg("JohnsonKinaseData")` package can be installed using the following code:

```{r installation, eval=FALSE}
if (!require("BiocManager", quietly = TRUE))
    install.packages("BiocManager")

BiocManager::install("ExperimentHub")
BiocManager::install("JohnsonKinaseData")
```

# Load PWM annotation

Annotation data for all provides kinase PWMs can be accessed with:

```{r load-anno}
library(JohnsonKinaseData)
anno <- getKinaseAnnotation()

head(anno)
```

Its includes PWM names and associated gene information, such as gene symbol, description, Entrez and Uniprot IDs. PWMs are classified by their specificity:

```{r anno-spec}
xtabs(~AcceptorSpecificity, anno)
```

Tyrosine specific kinase PWMs are additionally classified by sub-type: receptor (RTK), non-receptor (nRTK) and non-canonical tyrosine kinases (ncTK).

```{r anno-spec-sub}
xtabs(~AcceptorSpecificity + KinaseSubType, anno)
```

PWMs for non-canonical tyrosine kinases, i.e. kinases which also phosphorylate serine/threonine residues, are indicated by the `_TYR` suffix in the matrix name.

All PWMs are grouped into kinase families:

```{r anno-spec-family}
xtabs(~AcceptorSpecificity + KinaseFamily, anno)
```

# Loading kinase PWMs

Kinase PWMs can be loaded with the `getKinasePWM()` function which returns the full list of 396 kinase PWMs. 

```{r load-pwm}
library(JohnsonKinaseData)
pwms <- getKinasePWM()

head(names(pwms))
```

Each PWM is a numeric matrix with amino acids as rows and positions as columns. Matrix elements are log2-odd scores measuring differential affinity relative to a random frequency of amino acids [@Johnson2023]. 

```{r pwm-example}
pwms[["PLK2"]]
```

Beside the 20 standard amino acids, also phosphorylated serine, threonine and tyrosine residues are included. These phosphorylated residues are distinct from the central phospho-acceptor (serine, threonine or tyrosine at position `0`) and can have a strong impact on the affinity of a given kinase-substrate pair (phospho-priming). 

For serine/threonine specific kinase PWMs, the central phospho-acceptor measures the favorability of serine over threonine. The user can exclude this favorability measure by setting the parameter `includeSTfavorability` to `FALSE`, in which case the central position doesn't contribute to the PWM score.

```{r pwm-st}
getKinasePWM(includeSTfavorability=FALSE)[["PLK2"]]
```

In order to disable scoring of phosphosites that do no contain a matching phospho-acceptor, i.e. S/T in case of serine/threonine PWMs or K in case of tyrosine PWMs,  parameter `matchAcceptorSpecificity` can be set to `TRUE`. In this case the log2-odd score of non matching residues is set to `-Inf`:

```{r pwm-acc}
getKinasePWM(matchAcceptorSpecificity=TRUE)[["PLK2"]]
```

# Processing user-provided phosphosites

Phosphorylated peptides are often represented in two different formats: (1) the phosphorylated residues are indicated by an asterix as in `SAGLLS*DEDC`, (2) phosphorylated residues are given by lower case letters as in `SAGLLsDEDC`. In order to unify the phosophosite representation for PWM matching, `r Biocpkg("JohnsonKinaseData")` provides the function `processPhosphopeptides()`. It takes a character vector with phospho-peptides, aligns them to the central phospho-acceptor position and pads and/or truncates the surrounding residues. By default this means, 5 upstream residues, a central acceptor and 5 downstream residues. The central phospho-acceptor position is defined as the left closest phosphorylated residue to the midpoint of the peptide given by `floor(nchar(sites)/2)+1`. This midpoint definition is also the default alignment position if no phosphorylated residue was recognized.

```{r peps-central}
ppeps <- c("SAGLLS*DEDC", "GDtND", "EKGDSN__", "HKRNyGsDER", "PEKS*GyNV")

sites <- processPhosphopeptides(ppeps)

sites
```

If a peptide contains several phosphorylated residues, option `onlyCentralAcceptor` controls how to select the acceptor position. Setting `onlyCentralAcceptor=FALSE` will return all possible aligned phosphosites for a given input peptide. Note that in this case the output is not parallel to the input.

```{r peps-non-central}
sites <- processPhosphopeptides(ppeps, onlyCentralAcceptor=FALSE)

sites
```

A warning is raised if the central acceptor is not serine, threonine or tyrosine.

# Scoring of user-provided phosphosites

Once peptides are processed to sites, the function `scorePhosphosites()` can be used to create a matrix of kinase-substrate match scores. 

```{r score}
selected <- sites |> 
  dplyr::pull(processed)

scores <- scorePhosphosites(pwms, selected)

dim(scores)

scores[,1:5]
```

The PWM scoring can be parallelized by supplying a `BiocParallelParam` object to `BPPARAM=`. 

```{r score-parallel}
scores <- scorePhosphosites(pwms, selected, BPPARAM=BiocParallel::SerialParam())
```

By default, the resulting score is the log2-odds score of the PWM. Alternatively, by setting `scoreType="percentile"`, a percentile rank of the log2-odds score is calculated, using for each PWM a background score distribution. 

```{r score-percentile}
scores <- scorePhosphosites(pwms, selected, scoreType="percentile")

scores[,1:5]
```

Quantifying PWM matches by percentile rank was first described in Yaffe et al. 2001 [@Yaffe2001]. The background score distributions used here are derived from matching each PWM to either the 85'603 unique phosphosites published in Johnson et al. 2023 (serine/threonine PWMs) or the 6659 unique phosphosites published in Yaron-Barir et al. 2024 (tyrosine PWMs). They can be accessed with:

```{r background-tyr}
bg <- getBackgroundScores(phosphoAcceptor='Tyr')
```

where `phosphoAcceptor` can be either `Ser/Thr` or `Tyr`. The corresponding mappings of log2-odd scores to percentile ranks can be accessed with function `getScoreMaps()` which returns a list of mapping functions, one for each kinase PWM.

Note that these percentile ranks do not account for phospho-priming, as non-central phosphorylated residues were missing in the background sites. I.e. the percentile ranks cannot reflect the impact of phospho-priming.

# Session info

```{r session-info}
sessionInfo()
```

# References

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/score_phosphosites.R
\name{getKinasePWM}
\alias{getKinasePWM}
\title{Get a list of position specific weight matrices (PWMs) for human kinases}
\usage{
getKinasePWM(includeSTfavorability = TRUE, matchAcceptorSpecificity = FALSE)
}
\arguments{
\item{includeSTfavorability}{Include serine vs. threonine favorability for
the central phospho-acceptor?}

\item{matchAcceptorSpecificity}{Only score sites with a matching central
phospho-acceptor?}
}
\value{
A named list of numeric matrices (PWMs).
}
\description{
The function returns a named list of 396 kinase PWMs. Among these are 303
serine/threonine kinases, 78 canonical tyrosine kinases and 15 non-canonical
tyrosine kinases i.e. dual-specific kinases, indicated by the '_TYR' suffix.
}
\details{
Each PWM stores the log2-odds score per amino acid (23 rows) and position (10
or 11 columns) in matrix format. Beside the 20 standard amino acids also
phosphorylated serine, threonine and tyrosine residues are included.

The central phospho-acceptor position of each PWM is at position \code{0} (column
6). For serine/threonine specific kinases this position quantifies the
favorability of serine over threonine, but can be omitted when setting
'includeSTfavorability=FALSE'.

The specificity of a kinase PWM is controlled by parameter
'matchAcceptorSpecificity'. If set to 'TRUE', sites without a matching
acceptor are scored with '-Inf'.
}
\examples{
pwms <- getKinasePWM()
}
\references{
Johnson, J.L., Yaron, T.M., Huntsman, E.M. et al. An atlas of
substrate specificities for the human serine/threonine kinome. Nature 613,
759–766 (2023). https://doi.org/10.1038/s41586-022-05575-3

Yaron-Barir, T.M., Joughin, B.A., Huntsman, E.M. et al. The intrinsic
substrate specificity of the human tyrosine kinome. Nature 629, 1174–1181
(2024). https://doi.org/10.1038/s41586-024-07407-y
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/JohnsonKinaseData-package.R
\docType{package}
\name{JohnsonKinaseData-package}
\alias{JohnsonKinaseData}
\alias{JohnsonKinaseData-package}
\title{JohnsonKinaseData: Kinase PWMs based on data published by Johnson et al. 2023 and Yaron-Barir et al. 2024}
\description{
The packages provides position specific weight matrices (PWMs) for 303 human serine/threonine and 93 tyrosine kinases originally published in Johnson et al. 2023 (doi:10.1038/s41586-022-05575-3) and Yaron-Barir et al. 2024 (doi:10.1038/s41586-024-07407-y). The package includes basic functionality to score user provided phosphosites. It also includes pre-computed PWM scores ("background scores") for a large collection of curated human phosphosites which can be used to rank PWM scores relative to the background scores ("percentile rank").
}
\seealso{
Useful links:
\itemize{
  \item \url{https://github.com/fgeier/JohnsonKinaseData/}
  \item Report bugs at \url{https://support.bioconductor.org/t/JohnsonKinaseData}
}

}
\author{
\strong{Maintainer}: Florian Geier \email{florian.geier@unibas.ch} (\href{https://orcid.org/0000-0002-9076-9264}{ORCID})

}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/score_phosphosites.R
\name{scorePhosphosites}
\alias{scorePhosphosites}
\title{Match kinase PWMs to processed phosphosites}
\usage{
scorePhosphosites(
  pwms,
  sites,
  scoreType = c("lod", "percentile"),
  BPPARAM = BiocParallel::SerialParam()
)
}
\arguments{
\item{pwms}{List with kinase PWMs as returned by \link{getKinasePWM}.}

\item{sites}{A character vector with phosphosites. Check
\link{processPhosphopeptides} for the correct phosphosite format.}

\item{scoreType}{Log2-odds score or percentile rank.}

\item{BPPARAM}{A \link{BiocParallelParam} object specifying how parallelization
should be performed.}
}
\value{
A numeric matrix of size \code{length(sites)} times \code{length(pwms)}.
}
\description{
\code{scorePhosphosites} takes a list of kinase PWMs and a vector of processed
phosphosites as input and returns a matrix of match scores per PWM and site.
}
\details{
The match score is either the log2-odds score (\code{lod}) or the percentile rank
(\code{percentile}) in the background score distribution.
}
\examples{
score <- scorePhosphosites(getKinasePWM(), c("TGRRHTLAEV", "LISAVSPEIR"))
}
\seealso{
\link{getKinasePWM} for getting a list of kinase PWMs,
\link{processPhosphopeptides} for the correct phosphosite format, and
\link{getScoreMaps} for mapping PWM scores to percentile ranks
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/zzz.R
\name{getBackgroundScores}
\alias{getBackgroundScores}
\title{Get precomputed PWM scores for two sets of curated human phosphosites}
\usage{
getBackgroundScores(phosphoAcceptor = c("Ser/Thr", "Tyr"))
}
\arguments{
\item{phosphoAcceptor}{Return background scores for either Ser/Thr or Tyr
phosphosites}
}
\value{
A data frame with log2-odds scores per phosphosite (rows) and PWMs
(columns)
}
\description{
Two sets of background scores are provided:
}
\details{
\enumerate{
\item Ser/Thr phosphosites published in Johnson et al. 2023 2. Tyr phosphosites
published in Yaron-Barir et al. 2024
}

The background scores are derived from matching the corresponding PWMs to
each of the sets. The resulting data frames contain the log2-odds score per
phosphosite and PWM.
}
\examples{
bg <- getBackgroundScores(phosphoAcceptor='Tyr')
}
\references{
Johnson, J.L., Yaron, T.M., Huntsman, E.M. et al. An atlas of
substrate specificities for the human serine/threonine kinome. Nature 613,
759–766 (2023). https://doi.org/10.1038/s41586-022-05575-3

Yaron-Barir, T.M., Joughin, B.A., Huntsman, E.M. et al. The intrinsic
substrate specificity of the human tyrosine kinome. Nature 629, 1174–1181
(2024). https://doi.org/10.1038/s41586-024-07407-y
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/zzz.R
\name{getKinaseAnnotation}
\alias{getKinaseAnnotation}
\title{Get annnotation data for all kinase PWMs}
\usage{
getKinaseAnnotation()
}
\value{
A data frame with columns MatrixName, GeneName, UniprotID, EntrezID,
Description, AcceptorSpecificity, KinaseSubType and KinaseFamily
}
\description{
The annotation data records for each kinase PWM, the PWM matrix name, gene
symbol and description, Uniprot ID, Entrez ID, acceptor specificity, kinase
sub-type, as well as the kinase family.
}
\details{
Kinase PWMs are either serine/threonine or tyrosine specific in their central
phospho-acceptor. For dual-specific kinases, the tyrosine-specific PWM is
indicated by the '_TYR' suffix in the PWM name.

Tyrosine kinases are further distinguished by sub-type and include receptor
tyrosine kinases (RTK), non-receptor tyrosine kinases (nRTK) and
non-canonical tyrosine kinases (ncTK) with dual-specificity.
}
\examples{
anno <- getKinaseAnnotation()
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/process_phosphopeptides.R
\name{processPhosphopeptides}
\alias{processPhosphopeptides}
\title{processPhosphopetides}
\usage{
processPhosphopeptides(
  sites,
  onlyCentralAcceptor = TRUE,
  allowPhosphoPriming = TRUE,
  upstream = 5L,
  downstream = 5L
)
}
\arguments{
\item{sites}{Character vector with phospho-peptides}

\item{onlyCentralAcceptor}{Process only the central phospho-acceptor residue?}

\item{allowPhosphoPriming}{Allow phospho-acceptors at non-central positions?
These should be indicated by the lower case letters s, t or y.}

\item{upstream}{Number of bases upstream of central phospho-acceptor in the
processed output}

\item{downstream}{Number of bases downstream of central phospho-acceptor in
the processed output}
}
\value{
A tibble with columns: \code{sites}, \code{processed}, \code{acceptor}
}
\description{
Process phospho-peptides to a common format used for PWM matching
}
\details{
Phosphorylated residues are recognized either by lower case letters (s, t or
y) or the phosphorylated residue is followed by an asterisk (S*, T* or Y*).

If a peptide reports several phosphorylated residues, parameter
\code{onlyCentralAcceptor} allows for two processing options: (1) By default, only
the central phospho-acceptor of each phospho-peptide is considered. Here
central is defined as the left-closest position to \code{floor(nchar(site)/2)+1}.
(2) All phospho-acceptors are considered as central in which case the
phospho-peptide is replicated and aligned for each of its phosphorylated
residues. In this case the output sites are not in parallel to the input
peptides.

In both cases, non-central phospho-acceptors are indicated by lower case
letters (s, t, or y). These residues enable phospho-priming of the site. If
phospho-priming is disabled (parameter \code{allowPhosphoPriming}) these residues
are converted to upper case letters.

If a site does not follow the phosphorylation patterns described above, the
central residue defined by position \code{floor(nchar(site)/2)+1} is considered
the default phospho-acceptor site.

The input sites are truncated and/or padded such that the processed sites are
of width \code{upstream}+\code{downstream}+1. By default the central phospho-acceptor
is surrounded by 5 upstream and 5 downstream residues.

A warning is raised if the central phospho-acceptor is not serine, threonine
or tyrosine.
}
\examples{
procSites <- processPhosphopeptides(c("AGLLS*DEDC", "RtEKGS*N", "ETGKDN"))
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/score_phosphosites.R
\name{getScoreMaps}
\alias{getScoreMaps}
\title{Map log2-odds score to percentile rank}
\usage{
getScoreMaps()
}
\value{
A named list of functions, one for each kinase PWM. Each function is
taking a vector of log2-odds scores as input and returns the corresponding
percentile ranks.
}
\description{
For each kinase PWM, get a function that maps its log2-odds score to the
percentile rank in the background score distribution. The percentile rank of
a given score is the percentage of scores in corresponding background score
distribution that are less than or equal to that score. The background score
distribution per PWM is derived from matching each PWM to either the 85'603
unique phosphosites published in Johnson et al. 2023 (serine/threonine PWMs)
or the 6659 unique phosphosites published in Yaron-Barir et al. 2024
(tyrosine PWMs).
}
\details{
Note: since the background sites don't contain non-central phosphorylated
residues (phospho-priming), the percentile rank of an input site which
includes phospho-priming will be capped to 100, if its PWM score exceeds the
largest observed background score for that PWM.

Internally, \link[stats:approxfun]{stats::approxfun} is used to linearly interpolate between the
PWM score and its 0.1\% - quantile in the distribution over background scores.
This approximation allows for a lower memory footprint compared with the full
set of background scores.
}
\examples{
maps <- getScoreMaps()
}
